using System;
using System.Collections.Generic;
using System.Text;

using System.IO;

/////////////////////////////////////
// NEED ZIP.TXT IN APP/GEODATA DIR //
/////////////////////////////////////

namespace GMDL
{
    class comprCS
    {
        public comprCS()
        {
        }

        int MAXZIP = 20000; // USGS 2006 suggests 3232 max
        
        public int compr(string dir_name)
        {
            DirectoryInfo dir = new DirectoryInfo(dir_name);

	        int count = 0;

            string[] zips = new string[MAXZIP];
            string[] states = new string[MAXZIP];
            string[] citys = new string[MAXZIP];
	        long[] fsizes = new long[MAXZIP];
	        long[] lats = new long[MAXZIP];
	        long[] lons = new long[MAXZIP];
	        
            foreach (FileInfo d_name in dir.GetFiles())
            {
        	    string path = d_name.FullName;
	            zip_center(path, ref (lats[count]), ref (lons[count]));
                get_city_state(d_name.Name, ref states[count], ref citys[count]);
	            compressFile(path, path + ".new");
	            zips[count] = d_name.Name;
	            fsizes[count] = new FileInfo(path + ".new").Length;
	            count++;
  	        }

	        int i;
	        
            BinaryWriter result = new BinaryWriter(new FileStream(dir_name + "/geodata.dat", FileMode.CreateNew));

	        // zip(5) + lat(4) + lon(4) + st(2) + city(20) + size(4) + offset(4)
	        long offset = count * 43 + 5; // "#####" separator between index and zipped data
	        for (i = 0; i < count; i++)
            {
                /*string t1 = zips[i];
                int t2 = System.Convert.ToInt32(lats[i]);
                int t3 = System.Convert.ToInt32(lons[i]);
                string t2 = states[i];*/

                result.Write(zips[i].ToCharArray());
		        result.Write(System.Convert.ToInt32(lats[i]));
		        result.Write(System.Convert.ToInt32(lons[i]));
		        result.Write(states[i].ToCharArray());

                string city = citys[i].Trim();
                if (city.Length > 20)
                    city = city.Substring(0, 20);
                city = city + new String(' ', 20 - city.Length);
                result.Write(city.ToCharArray());
		        
                result.Write(System.Convert.ToInt32(fsizes[i]));
		        result.Write(System.Convert.ToInt32(offset));
                offset += fsizes[i];
	        }
	        
            result.Write(("#####").ToCharArray());
	        for (i = 0; i < count; i++)
            {
                result.Write(File.ReadAllBytes(dir_name + "/" + zips[i] + ".new"));
	        }
            result.Close();

            return 0;
        }

        // gives weighted, should be actual middle?
        int zip_center (string path, ref long lat, ref long lon)
        {
	        StreamReader fp = new StreamReader(path);
            long latsum = 0;
            long lonsum = 0;
	        long counter = 0;
            while (fp.EndOfStream == false)
            {
                string line = fp.ReadLine().Trim();
                if (line != "")
                {
                    line = line.Substring(line.LastIndexOf(",") + 1, line.Length - 1 - line.LastIndexOf(","));
                    int mid = line.LastIndexOf("+");
                    if (mid < line.LastIndexOf("-"))
                        mid = line.LastIndexOf("-");
                    lonsum += Int64.Parse(line.Substring(0, mid));
                    latsum += Int64.Parse(line.Substring(mid + 1, line.Length - 1 - mid));
                    counter++;
                }
	        }
            fp.Close();
	        if (counter > 0)
            {
		        lat = latsum / counter;
		        lon = lonsum / counter;
		        return 1;
	        }
	        return -1;
        }

        int get_city_state(string zip, ref string state, ref string city)
        {
	        StreamReader fp = new StreamReader("geodata/zip.txt");
            while(fp.EndOfStream == false)
            {
                string line = fp.ReadLine().Trim();
                if (line.StartsWith(zip))
                {
                    state = line.Substring(line.IndexOf(",") + 1, 2);
                    city = line.Substring(9, line.IndexOf(",", 9) - 9);
                    fp.Close();
                    return 1;
                }
	        }
            // an incomplete zip.txt
            state = "  ";
            city = ""; // will get padded elsewhere
            fp.Close();
	        return 0;
        }

        #region borrowed code
        // like def, but copied from zlib for VS2005 sample
        private void compressFile(string inFile, string outFile)
        {
            System.IO.FileStream outFileStream = new System.IO.FileStream(outFile, System.IO.FileMode.Create);
            zlib.ZOutputStream outZStream = new zlib.ZOutputStream(outFileStream, zlib.zlibConst.Z_DEFAULT_COMPRESSION);
            System.IO.FileStream inFileStream = new System.IO.FileStream(inFile, System.IO.FileMode.Open);
            //try
            //{
                CopyStream(inFileStream, outZStream);
            //}
            //finally
            //{
                outZStream.Close();
                outFileStream.Close();
                inFileStream.Close();
            //}
        }

        private void decompressFile(string inFile, string outFile)
        {
            System.IO.FileStream outFileStream = new System.IO.FileStream(outFile, System.IO.FileMode.Create);
            zlib.ZOutputStream outZStream = new zlib.ZOutputStream(outFileStream);
            System.IO.FileStream inFileStream = new System.IO.FileStream(inFile, System.IO.FileMode.Open);
            //try
            //{
                CopyStream(inFileStream, outZStream);
            //}
            //finally
            //{
                outZStream.Close();
                outFileStream.Close();
                inFileStream.Close();
            //}
        }

        private static void CopyStream(System.IO.Stream input, System.IO.Stream output)
        {
            byte[] buffer = new byte[2000];
            int len;
            while ((len = input.Read(buffer, 0, 2000)) > 0)
            {
                output.Write(buffer, 0, len);
            }
            output.Flush();
        }
        #endregion

        // for testing
        public void decompr(string dir_name)
        {
            string[] zips = new string[MAXZIP];
            int[] fsizes = new int[MAXZIP];

            BinaryReader sr = new BinaryReader(new FileStream(dir_name + "/geodata.dat", FileMode.Open));
            new DirectoryInfo(dir_name + "/geodata").Create();
            dir_name = dir_name + "/geodata";
            StreamWriter sw = new StreamWriter(dir_name + "/index.txt", false);

            bool keep_going = true;
            int count = 0;
            while (keep_going)
            {
                string zip = new String(sr.ReadChars(5));
                if (zip != "#####")
                {
                    zips[count] = zip;
                    sw.Write(zip + ",");
                    sw.Write(sr.ReadInt32().ToString() + ",");
                    sw.Write(sr.ReadInt32().ToString() + ",");
                    sw.Write(new String(sr.ReadChars(2)) + ",");
                    sw.Write(new String(sr.ReadChars(20)).Trim() + ",");
                    fsizes[count] = sr.ReadInt32();
                    sw.Write(fsizes[count].ToString() + ",");
                    sw.Write(sr.ReadInt32().ToString() + "\r");
                    count++;
                }
                else
                {
                    keep_going = false;
                }
            }
            sw.Close();
            
            int i = 0;
            while (i < count)
            {
                File.WriteAllBytes(dir_name + "/" + zips[i] +".new", sr.ReadBytes(fsizes[i]));
                decompressFile(dir_name + "/" + zips[i] + ".new", dir_name + "/" + zips[i]);
                i++;
            }
            sr.Close();
            

            /*
            // zip(5) + lat(4) + lon(4) + st(2) + city(20) + size(4) + offset(4)
            long offset = count * 43 + 5; // "#####" separator between index and zipped data
            for (i = 0; i < count; i++)
            {
                result.Write(zips[i]);
                result.Write(lats[i]);
                result.Write(lons[i]);
                result.Write(states[i]);

                string city = citys[i].Trim();
                if (city.Length > 20)
                    city = city.Substring(0, 20);
                city = city + new String(' ', 20 - city.Length);
                result.Write(citys[i]);

                result.Write(fsizes[i]);
                result.Write(offset);
                offset += fsizes[i];
            }

            result.Write("#####");
            for (i = 0; i < count; i++)
            {
                result.Write(File.ReadAllBytes(dir_name + "/" + zips[i]));
            }
            */
        }
    }
}
